Index: vfs/smbfs/smbfs_node.c
===================================================================
RCS file: /cvs/src/sys/vfs/smbfs/smbfs_node.c,v
retrieving revision 1.8
diff -u -r1.8 smbfs_node.c
--- vfs/smbfs/smbfs_node.c	10 Nov 2003 06:12:17 -0000	1.8
+++ vfs/smbfs/smbfs_node.c	22 Feb 2004 06:16:20 -0000
@@ -169,6 +169,7 @@
 	struct smbnode *np, *np2, *dnp;
 	struct vnode *vp;
 	u_long hashval;
+	lwkt_tokref vlock;
 	int error;
 
 	*vpp = NULL;
@@ -180,7 +181,7 @@
 		if (dvp == NULL)
 			return EINVAL;
 		vp = VTOSMB(VTOSMB(dvp)->n_parent)->n_vnode;
-		error = vget(vp, LK_EXCLUSIVE, td);
+		error = vget(vp, NULL, LK_EXCLUSIVE, td);
 		if (error == 0)
 			*vpp = vp;
 		return error;
@@ -203,9 +204,9 @@
 		if (np->n_parent != dvp ||
 		    np->n_nmlen != nmlen || bcmp(name, np->n_name, nmlen) != 0)
 			continue;
-		VI_LOCK(vp);
+		VI_LOCK(&vlock, vp);
 		smbfs_hash_unlock(smp, td);
-		if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td) != 0)
+		if (vget(vp, &vlock, LK_EXCLUSIVE | LK_INTERLOCK, td) != 0)
 			goto retry;
 		*vpp = vp;
 		return 0;
@@ -243,7 +244,7 @@
 		SMBERROR("new vnode '%s' born without parent ?\n", np->n_name);
 
 	lockinit(&np->n_lock, 0, "smbnode", VLKTIMEOUT, LK_CANRECURSE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 	smbfs_hash_lock(smp, td);
 	LIST_FOREACH(np2, nhpp, n_hash) {
@@ -295,6 +296,7 @@
 	struct vnode *dvp;
 	struct smbnode *np = VTOSMB(vp);
 	struct smbmount *smp = VTOSMBFS(vp);
+	lwkt_tokref vlock;
 	
 	SMBVDEBUG("%s,%d\n", np->n_name, vp->v_usecount);
 
@@ -316,9 +318,9 @@
 		smbfs_name_free(np->n_name);
 	FREE(np, M_SMBNODE);
 	if (dvp) {
-		VI_LOCK(dvp);
+		VI_LOCK(&vlock, dvp);
 		if (dvp->v_usecount >= 1) {
-			VI_UNLOCK(dvp);
+			VI_UNLOCK(&vlock, dvp);
 			vrele(dvp);
 			/*
 			 * Indicate that we released something; see comment
@@ -326,7 +328,7 @@
 			 */
 			smp->sm_didrele = 1;
 		} else {
-			VI_UNLOCK(dvp);
+			VI_UNLOCK(&vlock, dvp);
 			SMBERROR("BUG: negative use count for parent!\n");
 		}
 	}
@@ -358,7 +360,7 @@
 		   &np->n_mtime, &scred);
 		np->n_opencount = 0;
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (0);
 }
 /*
Index: vfs/smbfs/smbfs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/smbfs/smbfs_vfsops.c,v
retrieving revision 1.9
diff -u -r1.9 smbfs_vfsops.c
--- vfs/smbfs/smbfs_vfsops.c	12 Feb 2004 23:36:28 -0000	1.9
+++ vfs/smbfs/smbfs_vfsops.c	22 Feb 2004 19:57:42 -0000
@@ -224,7 +224,7 @@
 	error = smbfs_root(mp, &vp);
 	if (error)
 		goto bad;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	SMBVDEBUG("root.v_usecount = %d\n", vp->v_usecount);
 
 #ifdef DIAGNOSTICS
@@ -318,7 +318,7 @@
 	}
 	if (smp->sm_root) {
 		*vpp = SMBTOV(smp->sm_root);
-		return vget(*vpp, LK_EXCLUSIVE | LK_RETRY, td);
+		return vget(*vpp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	}
 	smb_makescred(&scred, td, cred);
 	error = smbfs_smb_lookup(NULL, NULL, 0, &fattr, &scred);
@@ -447,6 +447,8 @@
 	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist);
 	     vp != NULL;
 	     vp = TAILQ_NEXT(vp, v_nmntvnodes)) {
+		if (vp->v_flag & VPLACEMARKER)	/* ZZZ */
+			continue;
 		/*
 		 * If the vnode that we are about to sync is no longer
 		 * associated with this mount point, start over.
@@ -456,7 +458,7 @@
 		if (VOP_ISLOCKED(vp, NULL) || TAILQ_EMPTY(&vp->v_dirtyblkhd) ||
 		    waitfor == MNT_LAZY)
 			continue;
-		if (vget(vp, LK_EXCLUSIVE, td))
+		if (vget(vp, NULL, LK_EXCLUSIVE, td))
 			goto loop;
 		error = VOP_FSYNC(vp, waitfor, td);
 		if (error)
Index: vfs/smbfs/smbfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/smbfs/smbfs_vnops.c,v
retrieving revision 1.10
diff -u -r1.10 smbfs_vnops.c
--- vfs/smbfs/smbfs_vnops.c	22 Dec 2003 17:41:08 -0000	1.10
+++ vfs/smbfs/smbfs_vnops.c	22 Feb 2004 06:16:37 -0000
@@ -289,16 +289,17 @@
 	struct vnode *vp = ap->a_vp;
 	struct thread *td = ap->a_td;
 	int error, dolock;
+	lwkt_tokref vlock;
 
-	VI_LOCK(vp);
+	VI_LOCK(&vlock, vp);
 	dolock = (vp->v_flag & VXLOCK) == 0;
 	if (dolock)
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY | LK_INTERLOCK, td);
+		vn_lock(vp, &vlock, LK_EXCLUSIVE | LK_RETRY | LK_INTERLOCK, td);
 	else
-		VI_UNLOCK(vp);
+		VI_UNLOCK(&vlock, vp);
 	error = smbfs_closel(ap);
 	if (dolock)
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 	return error;
 }
 
@@ -1185,18 +1186,18 @@
 			error = 0;
 			SMBVDEBUG("cached '.'\n");
 		} else if (flags & CNP_ISDOTDOT) {
-			VOP_UNLOCK(dvp, 0, td);	/* unlock parent */
+			VOP_UNLOCK(dvp, NULL, 0, td);	/* unlock parent */
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
-			error = vget(vp, LK_EXCLUSIVE, td);
+			error = vget(vp, NULL, LK_EXCLUSIVE, td);
 			if (!error && lockparent && islastcn) {
-				error = vn_lock(dvp, LK_EXCLUSIVE, td);
+				error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 				if (error == 0)
 					cnp->cn_flags &= ~CNP_PDIRUNLOCK;
 			}
 		} else {
-			error = vget(vp, LK_EXCLUSIVE, td);
+			error = vget(vp, NULL, LK_EXCLUSIVE, td);
 			if (!lockparent || error || !islastcn) {
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 				cnp->cn_flags |= CNP_PDIRUNLOCK;
 			}
 		}
@@ -1213,9 +1214,9 @@
 			}
 			vput(vp);
 			if (lockparent && dvp != vp && islastcn)
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 		}
-		error = vn_lock(dvp, LK_EXCLUSIVE, td);
+		error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 		*vpp = NULLVP;
 		if (error) {
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
@@ -1252,7 +1253,7 @@
 				return error;
 			cnp->cn_flags |= CNP_SAVENAME;
 			if (!lockparent) {
-				VOP_UNLOCK(dvp, 0, td);
+				VOP_UNLOCK(dvp, NULL, 0, td);
 				cnp->cn_flags |= CNP_PDIRUNLOCK;
 			}
 			return (EJUSTRETURN);
@@ -1279,7 +1280,7 @@
 		*vpp = vp;
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent) {
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return 0;
@@ -1296,20 +1297,20 @@
 		*vpp = vp;
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent) {
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return 0;
 	}
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(dvp, 0, td);
+		VOP_UNLOCK(dvp, NULL, 0, td);
 		error = smbfs_nget(mp, dvp, name, nmlen, NULL, &vp);
 		if (error) {
-			vn_lock(dvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(dvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 			return error;
 		}
 		if (lockparent && islastcn) {
-			error = vn_lock(dvp, LK_EXCLUSIVE, td);
+			error = vn_lock(dvp, NULL, LK_EXCLUSIVE, td);
 			if (error) {
 				cnp->cn_flags |= CNP_PDIRUNLOCK;
 				vput(vp);
@@ -1327,7 +1328,7 @@
 		*vpp = vp;
 		SMBVDEBUG("lookup: getnewvp!\n");
 		if (!lockparent || !islastcn) {
-			VOP_UNLOCK(dvp, 0, td);
+			VOP_UNLOCK(dvp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 	}
Index: vfs/specfs/spec_vnops.c
===================================================================
RCS file: /cvs/src/sys/vfs/specfs/spec_vnops.c,v
retrieving revision 1.12
diff -u -r1.12 spec_vnops.c
--- vfs/specfs/spec_vnops.c	20 Aug 2003 09:56:33 -0000	1.12
+++ vfs/specfs/spec_vnops.c	22 Feb 2004 05:59:41 -0000
@@ -190,9 +190,9 @@
 	if (dev_dflags(dev) & D_TTY)
 		vp->v_flag |= VISTTY;
 
-	VOP_UNLOCK(vp, 0, ap->a_td);
+	VOP_UNLOCK(vp, NULL, 0, ap->a_td);
 	error = dev_dopen(dev, ap->a_mode, S_IFCHR, ap->a_td);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, ap->a_td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, ap->a_td);
 
 	if (error)
 		return (error);
@@ -249,9 +249,9 @@
 	if (uio->uio_resid == 0)
 		return (0);
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	error = dev_dread(dev, uio, ap->a_ioflag);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	return (error);
 }
 
@@ -279,9 +279,9 @@
 	uio = ap->a_uio;
 	td = uio->uio_td;
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	error = dev_dwrite(dev, uio, ap->a_ioflag);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	return (error);
 }
 
@@ -427,7 +427,7 @@
 	} */ *ap;
 {
 
-	VOP_UNLOCK(ap->a_vp, 0, ap->a_td);
+	VOP_UNLOCK(ap->a_vp, NULL, 0, ap->a_td);
 	return (0);
 }
 
Index: vfs/ufs/ffs_rawread.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ffs_rawread.c,v
retrieving revision 1.6
diff -u -r1.6 ffs_rawread.c
--- vfs/ufs/ffs_rawread.c	8 Sep 2003 18:26:39 -0000	1.6
+++ vfs/ufs/ffs_rawread.c	22 Feb 2004 05:32:51 -0000
@@ -105,7 +105,7 @@
 		if (VOP_ISLOCKED(vp, td) != LK_EXCLUSIVE) {
 			upgraded = 1;
 			/* Upgrade to exclusive lock, this might block */
-			VOP_LOCK(vp, LK_UPGRADE | LK_NOPAUSE, td);
+			VOP_LOCK(vp, NULL, LK_UPGRADE | LK_NOPAUSE, td);
 		} else
 			upgraded = 0;
 		
@@ -125,7 +125,7 @@
 			if (error != 0) {
 				splx(spl);
 				if (upgraded != 0)
-					VOP_LOCK(vp, LK_DOWNGRADE, td);
+					VOP_LOCK(vp, NULL, LK_DOWNGRADE, td);
 				return (error);
 			}
 		}
@@ -134,7 +134,7 @@
 			splx(spl);
 			if ((error = VOP_FSYNC(vp, MNT_WAIT, td)) != 0) {
 				if (upgraded != 0)
-					VOP_LOCK(vp, LK_DOWNGRADE, td);
+					VOP_LOCK(vp, NULL, LK_DOWNGRADE, td);
 				return (error);
 			}
 			spl = splbio();
@@ -144,7 +144,7 @@
 		}
 		splx(spl);
 		if (upgraded != 0)
-			VOP_LOCK(vp, LK_DOWNGRADE, td);
+			VOP_LOCK(vp, NULL, LK_DOWNGRADE, td);
 	} else {
 		splx(spl);
 	}
Index: vfs/ufs/ffs_softdep.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ffs_softdep.c,v
retrieving revision 1.12
diff -u -r1.12 ffs_softdep.c
--- vfs/ufs/ffs_softdep.c	16 Feb 2004 19:48:51 -0000	1.12
+++ vfs/ufs/ffs_softdep.c	22 Feb 2004 05:59:47 -0000
@@ -820,9 +820,9 @@
 			if (softdep_process_worklist(oldmnt) == 0)
 				break;
 		}
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		error = VOP_FSYNC(devvp, MNT_WAIT, td);
-		VOP_UNLOCK(devvp, 0, td);
+		VOP_UNLOCK(devvp, NULL, 0, td);
 		if (error)
 			break;
 	}
@@ -3978,9 +3978,9 @@
 		 * ufs_lookup for details on possible races.
 		 */
 		FREE_LOCK(&lk);
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		error = VFS_VGET(mnt, parentino, &pvp);
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		if (error != 0)
 			return (error);
 		if (flushparent) {
Index: vfs/ufs/ffs_vfsops.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ffs_vfsops.c,v
retrieving revision 1.13
diff -u -r1.13 ffs_vfsops.c
--- vfs/ufs/ffs_vfsops.c	8 Feb 2004 05:56:10 -0000	1.13
+++ vfs/ufs/ffs_vfsops.c	22 Feb 2004 22:33:53 -0000
@@ -224,13 +224,13 @@
 			 * that user has necessary permissions on the device.
 			 */
 			if (cred->cr_uid != 0) {
-				vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+				vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 				if ((error = VOP_ACCESS(devvp, VREAD | VWRITE,
 				    cred, td)) != 0) {
-					VOP_UNLOCK(devvp, 0, td);
+					VOP_UNLOCK(devvp, NULL, 0, td);
 					return (error);
 				}
-				VOP_UNLOCK(devvp, 0, td);
+				VOP_UNLOCK(devvp, NULL, 0, td);
 			}
 
 			fs->fs_flags &= ~FS_UNCLEAN;
@@ -304,12 +304,12 @@
 		accessmode = VREAD;
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			accessmode |= VWRITE;
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		if ((error = VOP_ACCESS(devvp, accessmode, cred, td)) != 0) {
 			vput(devvp);
 			return (error);
 		}
-		VOP_UNLOCK(devvp, 0, td);
+		VOP_UNLOCK(devvp, NULL, 0, td);
 	}
 
 	if (mp->mnt_flag & MNT_UPDATE) {
@@ -419,19 +419,32 @@
  *	5) invalidate all cached file data.
  *	6) re-read inode data for all active vnodes.
  */
+
+static int ffs_reload_scan1(struct mount *mp, struct vnode *vp, void *data);
+static int ffs_reload_scan2(struct mount *mp, struct vnode *vp,
+				lwkt_tokref_t vlock, void *data);
+
+struct scaninfo {
+	int rescan;
+	struct fs *fs;
+	struct vnode *devvp;
+	thread_t td;
+	int waitfor;
+	int allerror;
+};
+
 static int
 ffs_reload(struct mount *mp, struct ucred *cred, struct thread *td)
 {
-	struct vnode *vp, *nvp, *devvp;
-	struct inode *ip;
+	struct vnode *devvp;
 	void *space;
 	struct buf *bp;
 	struct fs *fs, *newfs;
 	struct partinfo dpart;
 	dev_t dev;
 	int i, blks, size, error;
-	int gen;
-	int vgen;
+	lwkt_tokref vlock;
+	struct scaninfo scaninfo;
 	int32_t *lp;
 
 	if ((mp->mnt_flag & MNT_RDONLY) == 0)
@@ -440,9 +453,9 @@
 	 * Step 1: invalidate all cached meta-data.
 	 */
 	devvp = VFSTOUFS(mp)->um_devvp;
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = vinvalbuf(devvp, 0, td, 0, 0);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		panic("ffs_reload: dirty1");
 
@@ -453,10 +466,10 @@
 	 * block device.  See ffs_mountmfs() for more details.
 	 */
 	if (devvp->v_tag != VT_MFS && vn_isdisk(devvp, NULL)) {
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		vfs_object_create(devvp, td);
-		lwkt_gettoken(&devvp->v_interlock);
-		VOP_UNLOCK(devvp, LK_INTERLOCK, td);
+		lwkt_gettoken(&vlock, devvp->v_interlock);
+		VOP_UNLOCK(devvp, &vlock, LK_INTERLOCK, td);
 	}
 
 	/*
@@ -522,57 +535,69 @@
 			*lp++ = fs->fs_contigsumsize;
 	}
 
-	gen = lwkt_gettoken(&mntvnode_token);
-loop:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nvp) {
-		if (vp->v_mount != mp) {
-			lwkt_gentoken(&mntvnode_token, &gen);
-			goto loop;
-		}
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		/*
-		 * Step 4: invalidate all inactive vnodes. 
-		 */
-		if (vrecycle(vp, NULL, td)) {
-			lwkt_gentoken(&mntvnode_token, &gen);
-			goto loop;
-		}
-		/*
-		 * Step 5: invalidate all cached file data.
-		 */
-		vgen = lwkt_gettoken(&vp->v_interlock);
-		if (lwkt_gentoken(&mntvnode_token, &gen) != 0 ||
-		    lwkt_gentoken(&vp->v_interlock, &vgen) != 0) {
-			lwkt_reltoken(&vp->v_interlock);
-			lwkt_gentoken(&mntvnode_token, &gen);
-			goto loop;
-		}
-		if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td)) {
-			lwkt_gentoken(&mntvnode_token, &gen);
-			goto loop;
-		}
-		if (vinvalbuf(vp, 0, td, 0, 0))
-			panic("ffs_reload: dirty2");
-		/*
-		 * Step 6: re-read inode data for all active vnodes.
-		 */
-		ip = VTOI(vp);
-		error =
-		    bread(devvp, fsbtodb(fs, ino_to_fsba(fs, ip->i_number)),
-		    (int)fs->fs_bsize, &bp);
-		if (error) {
-			vput(vp);
-			lwkt_reltoken(&mntvnode_token);
-			return (error);
-		}
-		ip->i_din = *((struct dinode *)bp->b_data +
-		    ino_to_fsbo(fs, ip->i_number));
-		ip->i_effnlink = ip->i_nlink;
-		brelse(bp);
+	scaninfo.rescan = 0;
+	scaninfo.fs = fs;
+	scaninfo.devvp = devvp;
+	scaninfo.td = td;
+	while (error == 0 && scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		error = vmntvnodescan(mp, ffs_reload_scan1, 
+				    ffs_reload_scan2, &scaninfo);
+	}
+	return(error);
+}
+
+static 
+int
+ffs_reload_scan1(struct mount *mp, struct vnode *vp, void *data)
+{
+	struct scaninfo *info = data;
+
+	/*
+	 * Step 4: invalidate all inactive vnodes. 
+	 */
+	if (vrecycle(vp, NULL, curthread)) {
+		info->rescan = 1;
+		return(-1);	/* continue loop, do not call scan2 */
+	}
+	return(0);
+}
+
+static
+int
+ffs_reload_scan2(struct mount *mp, struct vnode *vp, lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	struct inode *ip;
+	struct buf *bp;
+	int error;
+
+	/*
+	 * Step 5: invalidate all cached file data.
+	 */
+	if (vget(vp, vlock, LK_EXCLUSIVE | LK_INTERLOCK, info->td)) {
+		info->rescan = 1;
+		return(0);
+	}
+	if (vinvalbuf(vp, 0, info->td, 0, 0))
+		panic("ffs_reload: dirty2");
+	/*
+	 * Step 6: re-read inode data for all active vnodes.
+	 */
+	ip = VTOI(vp);
+	error = bread(info->devvp,
+			fsbtodb(info->fs, ino_to_fsba(info->fs, ip->i_number)),
+			(int)info->fs->fs_bsize, &bp);
+	if (error) {
 		vput(vp);
+		return (error);
 	}
-	lwkt_reltoken(&mntvnode_token);
-	return (0);
+	ip->i_din = *((struct dinode *)bp->b_data +
+	    ino_to_fsbo(info->fs, ip->i_number));
+	ip->i_effnlink = ip->i_nlink;
+	brelse(bp);
+	vput(vp);
+	return(0);
 }
 
 /*
@@ -592,6 +617,7 @@
 	struct partinfo dpart;
 	void *space;
 	int error, i, blks, size, ronly;
+	lwkt_tokref vlock;
 	int32_t *lp;
 	u_int64_t maxfilesize;					/* XXX */
 	size_t strsize;
@@ -611,9 +637,9 @@
 
 	if (ncount > 1 && devvp != rootvp)
 		return (EBUSY);
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = vinvalbuf(devvp, V_SAVE, td, 0, 0);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		return (error);
 
@@ -624,16 +650,16 @@
 	 * increases the opportunity for metadata caching.
 	 */
 	if (devvp->v_tag != VT_MFS && vn_isdisk(devvp, NULL)) {
-		vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		vfs_object_create(devvp, td);
-		lwkt_gettoken(&devvp->v_interlock);
-		VOP_UNLOCK(devvp, LK_INTERLOCK, td);
+		lwkt_gettoken(&vlock, devvp->v_interlock);
+		VOP_UNLOCK(devvp, &vlock, LK_INTERLOCK, td);
 	}
 
 	ronly = (mp->mnt_flag & MNT_RDONLY) != 0;
-	vn_lock(devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_OPEN(devvp, ronly ? FREAD : FREAD|FWRITE, FSCRED, td);
-	VOP_UNLOCK(devvp, 0, td);
+	VOP_UNLOCK(devvp, NULL, 0, td);
 	if (error)
 		return (error);
 	if (devvp->v_rdev->si_iosize_max != 0)
@@ -911,9 +937,9 @@
 	/*
 	 * Flush filesystem metadata.
 	 */
-	vn_lock(ump->um_devvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ump->um_devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_FSYNC(ump->um_devvp, MNT_WAIT, td);
-	VOP_UNLOCK(ump->um_devvp, 0, td);
+	VOP_UNLOCK(ump->um_devvp, NULL, 0, td);
 	return (error);
 }
 
@@ -955,88 +981,47 @@
  *
  * Note: we are always called with the filesystem marked `MPBUSY'.
  */
+
+
+static int ffs_sync_scan1(struct mount *mp, struct vnode *vp, void *data);
+static int ffs_sync_scan2(struct mount *mp, struct vnode *vp,
+                lwkt_tokref_t vlock, void *data);
+
 int
 ffs_sync(struct mount *mp, int waitfor, struct thread *td)
 {
-	struct vnode *nvp, *vp;
-	struct inode *ip;
 	struct ufsmount *ump = VFSTOUFS(mp);
 	struct fs *fs;
-	int error, allerror = 0;
+	int error;
+	struct scaninfo scaninfo;
 
 	fs = ump->um_fs;
 	if (fs->fs_fmod != 0 && fs->fs_ronly != 0) {		/* XXX */
 		printf("fs = %s\n", fs->fs_fsmnt);
 		panic("ffs_sync: rofs mod");
 	}
+
 	/*
 	 * Write back each (modified) inode.
 	 */
-	lwkt_gettoken(&mntvnode_token);
-loop:
-	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nvp) {
-		/*
-		 * If the vnode that we are about to sync is no longer
-		 * associated with this mount point, start over.
-		 */
-		if (vp->v_mount != mp)
-			goto loop;
-
-		/*
-		 * Depend on the mntvnode_token to keep things stable enough
-		 * for a quick test.  Since there might be hundreds of 
-		 * thousands of vnodes, we cannot afford even a subroutine
-		 * call unless there's a good chance that we have work to do.
-		 */
-		nvp = TAILQ_NEXT(vp, v_nmntvnodes);
-		ip = VTOI(vp);
-		if (vp->v_type == VNON || ((ip->i_flag &
-		     (IN_ACCESS | IN_CHANGE | IN_MODIFIED | IN_UPDATE)) == 0 &&
-		     TAILQ_EMPTY(&vp->v_dirtyblkhd))) {
-			continue;
-		}
-		if (vp->v_type != VCHR) {
-			lwkt_reltoken(&mntvnode_token);
-			error = vget(vp, LK_EXCLUSIVE | LK_NOWAIT, td);
-			if (error) {
-				lwkt_gettoken(&mntvnode_token);
-				if (error == ENOENT)
-					goto loop;
-			} else {
-				if ((error = VOP_FSYNC(vp, waitfor, td)) != 0)
-					allerror = error;
-				VOP_UNLOCK(vp, 0, td);
-				vrele(vp);
-				lwkt_gettoken(&mntvnode_token);
-			}
-		} else {
-			/*
-			 * We must reference the vp to prevent it from
-			 * getting ripped out from under UFS_UPDATE, since
-			 * we are not holding a vnode lock.  XXX why aren't
-			 * we holding a vnode lock?
-			 */
-			VREF(vp);
-			lwkt_reltoken(&mntvnode_token);
-			/* UFS_UPDATE(vp, waitfor == MNT_WAIT); */
-			UFS_UPDATE(vp, 0);
-			vrele(vp);
-			lwkt_gettoken(&mntvnode_token);
-		}
-		if (TAILQ_NEXT(vp, v_nmntvnodes) != nvp)
-			goto loop;
+	scaninfo.allerror = 0;
+	scaninfo.rescan = 1;
+	scaninfo.waitfor = waitfor;
+	while (scaninfo.rescan) {
+		scaninfo.rescan = 0;
+		vmntvnodescan(mp, ffs_sync_scan1, ffs_sync_scan2, &scaninfo);
 	}
-	lwkt_reltoken(&mntvnode_token);
+
 	/*
 	 * Force stale file system control information to be flushed.
 	 */
 	if (waitfor != MNT_LAZY) {
 		if (ump->um_mountp->mnt_flag & MNT_SOFTDEP)
 			waitfor = MNT_NOWAIT;
-		vn_lock(ump->um_devvp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(ump->um_devvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		if ((error = VOP_FSYNC(ump->um_devvp, waitfor, td)) != 0)
-			allerror = error;
-		VOP_UNLOCK(ump->um_devvp, 0, td);
+			scaninfo.allerror = error;
+		VOP_UNLOCK(ump->um_devvp, NULL, 0, td);
 	}
 #ifdef QUOTA
 	qsync(mp);
@@ -1045,8 +1030,75 @@
 	 * Write back modified superblock.
 	 */
 	if (fs->fs_fmod != 0 && (error = ffs_sbupdate(ump, waitfor)) != 0)
-		allerror = error;
-	return (allerror);
+		scaninfo.allerror = error;
+	return (scaninfo.allerror);
+}
+
+static
+int
+ffs_sync_scan1(struct mount *mp, struct vnode *vp, void *data)
+{
+	struct inode *ip;
+
+	/*
+	 * Depend on the mount list's vnode lock to keep things stable 
+	 * enough for a quick test.  Since there might be hundreds of 
+	 * thousands of vnodes, we cannot afford even a subroutine
+	 * call unless there's a good chance that we have work to do.
+	 */
+	ip = VTOI(vp);
+	if (vp->v_type == VNON || ((ip->i_flag &
+	     (IN_ACCESS | IN_CHANGE | IN_MODIFIED | IN_UPDATE)) == 0 &&
+	     TAILQ_EMPTY(&vp->v_dirtyblkhd))) {
+		return(-1);
+	}
+	return(0);
+}
+
+static
+int 
+ffs_sync_scan2(struct mount *mp, struct vnode *vp,
+                lwkt_tokref_t vlock, void *data)
+{
+	struct scaninfo *info = data;
+	thread_t td = curthread;	/* XXX */
+	struct inode *ip;
+	int error;
+
+	/*
+	 * We have to recheck after having obtained the vnode interlock.
+	 */
+	ip = VTOI(vp);
+	if (vp->v_type == VNON || ((ip->i_flag &
+	     (IN_ACCESS | IN_CHANGE | IN_MODIFIED | IN_UPDATE)) == 0 &&
+	     TAILQ_EMPTY(&vp->v_dirtyblkhd))) {
+		lwkt_reltoken(vlock);
+		return(0);
+	}
+	if (vp->v_type != VCHR) {
+		error = vget(vp, vlock, LK_INTERLOCK|LK_EXCLUSIVE|LK_NOWAIT, td);
+		if (error) {
+			if (error == ENOENT)
+				info->rescan = 1;
+		} else {
+			if ((error = VOP_FSYNC(vp, info->waitfor, td)) != 0)
+				info->allerror = error;
+			VOP_UNLOCK(vp, NULL, 0, td);
+			vrele(vp);
+		}
+	} else {
+		/*
+		 * We must reference the vp to prevent it from
+		 * getting ripped out from under UFS_UPDATE, since
+		 * we are not holding a vnode lock.
+		 */
+		VREF(vp);
+		lwkt_reltoken(vlock);
+		/* UFS_UPDATE(vp, waitfor == MNT_WAIT); */
+		UFS_UPDATE(vp, 0);
+		vrele(vp);
+	}
+	return(0);
 }
 
 /*
Index: vfs/ufs/ufs_ihash.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ufs_ihash.c,v
retrieving revision 1.10
diff -u -r1.10 ufs_ihash.c
--- vfs/ufs/ufs_ihash.c	15 Jan 2004 20:17:36 -0000	1.10
+++ vfs/ufs/ufs_ihash.c	22 Feb 2004 21:21:27 -0000
@@ -63,7 +63,7 @@
 ufs_ihashinit()
 {
 	ihashtbl = hashinit(desiredvnodes, M_UFSIHASH, &ihash);
-	lwkt_inittoken(&ufs_ihash_token);
+	lwkt_token_init(&ufs_ihash_token);
 }
 
 /*
@@ -76,13 +76,14 @@
 	ino_t inum;
 {
 	struct inode *ip;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&ufs_ihash_token);
+	lwkt_gettoken(&ilock, &ufs_ihash_token);
 	for (ip = INOHASH(dev, inum)->lh_first; ip; ip = ip->i_hash.le_next) {
 		if (inum == ip->i_number && dev == ip->i_dev)
 			break;
 	}
-	lwkt_reltoken(&ufs_ihash_token);
+	lwkt_reltoken(&ilock);
 
 	if (ip)
 		return (ITOV(ip));
@@ -93,50 +94,45 @@
  * Use the device/inum pair to find the incore inode, and return a pointer
  * to it. If it is in core, but locked, wait for it.
  *
- * Any time we potentially block we must regenerate the token using 
- * lwkt_gentoken(), which at the same time checks the generation number
- * indicating whether another entity stole the token while we were blocked.
- * In the best case lwkt_gentoken().   The code below is probably overkill,
- * but it is particularly important to check the generation number after
- * acquiring the vnode lock to ensure that the inode association is still
- * valid.
+ * Note that the serializing tokens do not prevent other processes from
+ * playing with the data structure being protected while we are blocked.
+ * They do protect us from preemptive interrupts which might try to
+ * play with the protected data structure.
  */
 struct vnode *
 ufs_ihashget(dev_t dev, ino_t inum)
 {
 	struct thread *td = curthread;	/* XXX */
+	lwkt_tokref ilock;
+	lwkt_tokref vlock;
 	struct inode *ip;
 	struct vnode *vp;
-	int gen;
 
-	gen = lwkt_gettoken(&ufs_ihash_token);
+	lwkt_gettoken(&ilock, &ufs_ihash_token);
 loop:
 	for (ip = INOHASH(dev, inum)->lh_first; ip; ip = ip->i_hash.le_next) {
-		if (inum == ip->i_number && dev == ip->i_dev) {
-			vp = ITOV(ip);
-			vhold(vp);
-			lwkt_gettoken(&vp->v_interlock);
-			if (lwkt_gentoken(&ufs_ihash_token, &gen) != 0) {
-				lwkt_reltoken(&vp->v_interlock);
-				vdrop(vp);
-				goto loop;
-			}
-			if (vget(vp, LK_EXCLUSIVE | LK_INTERLOCK, td)) {
-				vdrop(vp);
-				lwkt_gentoken(&ufs_ihash_token, &gen);
-				goto loop;
-			}
-			if (lwkt_reltoken(&ufs_ihash_token) != gen) {
-				vdrop(vp);
-				vput(vp);
-				gen = lwkt_gettoken(&ufs_ihash_token);
-				goto loop;
-			}
-			vdrop(vp);
-			return (vp);
+		if (inum != ip->i_number || dev != ip->i_dev)
+			continue;
+		vp = ITOV(ip);
+		lwkt_gettoken(&vlock, vp->v_interlock);
+		/*
+		 * We must check to see if the inode has been ripped
+		 * out from under us after blocking.
+		 */
+		for (ip = INOHASH(dev, inum)->lh_first; ip; ip = ip->i_hash.le_next) {
+			if (inum == ip->i_number && dev == ip->i_dev)
+				break;
 		}
+		if (ip == NULL || ITOV(ip) != vp) {
+			lwkt_reltoken(&vlock);
+			goto loop;
+		}
+		if (vget(vp, &vlock, LK_EXCLUSIVE | LK_INTERLOCK, td))
+			goto loop;
+		lwkt_reltoken(&ilock);
+		return (vp);
 	}
-	lwkt_reltoken(&ufs_ihash_token);
+	lwkt_reltoken(&ilock);
 	return (NULL);
 }
 
@@ -148,15 +144,16 @@
 {
 	struct thread *td = curthread;		/* XXX */
 	struct ihashhead *ipp;
+	lwkt_tokref ilock;
 
 	/* lock the inode, then put it on the appropriate hash list */
 	lockmgr(&ip->i_lock, LK_EXCLUSIVE, NULL, td);
 
-	lwkt_gettoken(&ufs_ihash_token);
+	lwkt_gettoken(&ilock, &ufs_ihash_token);
 	ipp = INOHASH(ip->i_dev, ip->i_number);
 	LIST_INSERT_HEAD(ipp, ip, i_hash);
 	ip->i_flag |= IN_HASHED;
-	lwkt_reltoken(&ufs_ihash_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -166,7 +163,9 @@
 ufs_ihashrem(ip)
 	struct inode *ip;
 {
-	lwkt_gettoken(&ufs_ihash_token);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &ufs_ihash_token);
 	if (ip->i_flag & IN_HASHED) {
 		ip->i_flag &= ~IN_HASHED;
 		LIST_REMOVE(ip, i_hash);
@@ -175,5 +174,5 @@
 		ip->i_hash.le_prev = NULL;
 #endif
 	}
-	lwkt_reltoken(&ufs_ihash_token);
+	lwkt_reltoken(&ilock);
 }
Index: vfs/ufs/ufs_inode.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ufs_inode.c,v
retrieving revision 1.6
diff -u -r1.6 ufs_inode.c
--- vfs/ufs/ufs_inode.c	7 Aug 2003 21:17:44 -0000	1.6
+++ vfs/ufs/ufs_inode.c	22 Feb 2004 05:45:51 -0000
@@ -97,7 +97,7 @@
 	if (ip->i_flag & (IN_ACCESS | IN_CHANGE | IN_MODIFIED | IN_UPDATE))
 		UFS_UPDATE(vp, 0);
 out:
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	/*
 	 * If we are done with the inode, reclaim it
 	 * so that it can be reused immediately.
Index: vfs/ufs/ufs_lookup.c
===================================================================
RCS file: /cvs/src/sys/vfs/ufs/ufs_lookup.c,v
retrieving revision 1.8
diff -u -r1.8 ufs_lookup.c
--- vfs/ufs/ufs_lookup.c	9 Oct 2003 22:27:27 -0000	1.8
+++ vfs/ufs/ufs_lookup.c	22 Feb 2004 06:00:25 -0000
@@ -443,7 +443,7 @@
 		 */
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent) {
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return (EJUSTRETURN);
@@ -507,10 +507,10 @@
 			return (0);
 		}
 		if (flags & CNP_ISDOTDOT)
-			VOP_UNLOCK(vdp, 0, td);	/* race to get the inode */
+			VOP_UNLOCK(vdp, NULL, 0, td);/* race to get the inode */
 		error = VFS_VGET(vdp->v_mount, dp->i_ino, &tdp);
 		if (flags & CNP_ISDOTDOT) {
-			if (vn_lock(vdp, LK_EXCLUSIVE | LK_RETRY, td) != 0)
+			if (vn_lock(vdp, NULL, LK_EXCLUSIVE | LK_RETRY, td) != 0)
 				cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		if (error)
@@ -530,7 +530,7 @@
 		}
 		*vpp = tdp;
 		if (!lockparent) {
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return (0);
@@ -552,10 +552,10 @@
 		if (dp->i_number == dp->i_ino)
 			return (EISDIR);
 		if (flags & CNP_ISDOTDOT)
-			VOP_UNLOCK(vdp, 0, td);	/* race to get the inode */
+			VOP_UNLOCK(vdp, NULL, 0, td);	/* race to get the inode */
 		error = VFS_VGET(vdp->v_mount, dp->i_ino, &tdp);
 		if (flags & CNP_ISDOTDOT) {
-			if (vn_lock(vdp, LK_EXCLUSIVE | LK_RETRY, td) != 0)
+			if (vn_lock(vdp, NULL, LK_EXCLUSIVE | LK_RETRY, td) != 0)
 				cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		if (error)
@@ -563,7 +563,7 @@
 		*vpp = tdp;
 		cnp->cn_flags |= CNP_SAVENAME;
 		if (!lockparent) {
-			VOP_UNLOCK(vdp, 0, td);
+			VOP_UNLOCK(vdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		return (0);
@@ -590,15 +590,15 @@
 	 */
 	pdp = vdp;
 	if (flags & CNP_ISDOTDOT) {
-		VOP_UNLOCK(pdp, 0, td);	/* race to get the inode */
+		VOP_UNLOCK(pdp, NULL, 0, td);	/* race to get the inode */
 		cnp->cn_flags |= CNP_PDIRUNLOCK;
 		if ((error = VFS_VGET(vdp->v_mount, dp->i_ino, &tdp)) != 0) {
-			if (vn_lock(pdp, LK_EXCLUSIVE | LK_RETRY, td) == 0)
+			if (vn_lock(pdp, NULL, LK_EXCLUSIVE | LK_RETRY, td) == 0)
 				cnp->cn_flags &= ~CNP_PDIRUNLOCK;
 			return (error);
 		}
 		if (lockparent && (flags & CNP_ISLASTCN)) {
-			if ((error = vn_lock(pdp, LK_EXCLUSIVE, td)) != 0) {
+			if ((error = vn_lock(pdp, NULL, LK_EXCLUSIVE, td)) != 0) {
 				vput(tdp);
 				return (error);
 			}
@@ -613,7 +613,7 @@
 		if (error)
 			return (error);
 		if (!lockparent || !(flags & CNP_ISLASTCN)) {
-			VOP_UNLOCK(pdp, 0, td);
+			VOP_UNLOCK(pdp, NULL, 0, td);
 			cnp->cn_flags |= CNP_PDIRUNLOCK;
 		}
 		*vpp = tdp;
@@ -945,14 +945,14 @@
 	 */
 	if (error == 0 && dp->i_endoff && dp->i_endoff < dp->i_size) {
 		if (tvp != NULL)
-			VOP_UNLOCK(tvp, 0, td);
+			VOP_UNLOCK(tvp, NULL, 0, td);
 #ifdef UFS_DIRHASH
 		if (dp->i_dirhash != NULL)
 			ufsdirhash_dirtrunc(dp, dp->i_endoff);
 #endif
 		(void) UFS_TRUNCATE(dvp, (off_t)dp->i_endoff, IO_SYNC, cred, td);
 		if (tvp != NULL)
-			vn_lock(tvp, LK_EXCLUSIVE | LK_RETRY, td);
+			vn_lock(tvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	}
 	return (error);
 }
